<script>
import { minValue, required, requiredIf } from 'vuelidate/lib/validators';
import { settingService } from '../../../services'
import { error_message, success_message } from '../../../Helper/helper';
import config from '../../../config';

export default {
  data() {
    return {
        config:config,
        setting: {
            wallet_status:'inactive',
            maximum_wallet_amount:'',
            wallet_recharge_limit:'',
            customer_wallet_recharge:'inactive',
            loyalty_cash_status:'inactive',
            loyalty_cash_minimum_item_total:'',
            loyalty_cash_percentage:'',
            is_referral_enable:'no',
            referral_amount:'',
            referee_amount:''
        },
    };
  },
  mounted(){
    this.getSetting();
  },
  validations:{
    setting:{
        maximum_wallet_amount:{
            required,
            minValue:minValue(0)
        },
        wallet_recharge_limit:{
            required,
            minValue:minValue(0)
        },
        loyalty_cash_minimum_item_total:{
            required:requiredIf(function(){
                return this.setting.loyalty_cash_status == 'active'
            }),
            minValue:minValue(0)
        },
        loyalty_cash_percentage:{
            required:requiredIf(function(){
                return this.setting.loyalty_cash_status == 'active'
            }),
            minValue:minValue(0)
        },
        referral_amount:{
            required:requiredIf(function(){
                return this.setting.is_referral_enable == 'yes'
            }),
            minValue:minValue(0)
        },
        referee_amount:{
            required:requiredIf(function(){
                return this.setting.is_referral_enable == 'yes'
            }),
            minValue:minValue(0)
        }

    }

  },
  methods: {
    getSetting(){
        settingService.getSetting().then((response) => {
            if (response.data.code === 200) {
                this.setting.wallet_status = response.data.result.wallet_status??'inactive',
                this.setting.maximum_wallet_amount = response.data.result.maximum_wallet_amount??'',
                this.setting.wallet_recharge_limit = response.data.result.wallet_recharge_limit??'',
                this.setting.customer_wallet_recharge = response.data.result.customer_wallet_recharge??'inactive',
                this.setting.loyalty_cash_status = response.data.result.loyalty_cash_status??'inactive',
                this.setting.loyalty_cash_minimum_item_total = response.data.result.loyalty_cash_minimum_item_total??'',
                this.setting.loyalty_cash_percentage = response.data.result.loyalty_cash_percentage??'',
                this.setting.is_referral_enable = response.data.result.is_referral_enable??'no',
                this.setting.referral_amount = response.data.result.referral_amount??'',
                this.setting.referee_amount = response.data.result.referee_amount??''

            } else {
                error_message(response.data.message);
            }
        })
    },
    fromSubmit(){
        this.$v.setting.$touch()
        if(this.$v.setting.$invalid){
            return false;
        }else{
            settingService.updateSetting({data:this.setting}).then((response) => {
                if (response.data.code === 200) {
                    success_message(response.data.message);
                    this.getSetting()
                    this.$auth.setUser()
                } else {
                    error_message(response.data.message);
                }
            })
        }
    },
  },

};
</script>

<template>
    <div>
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <form @submit.prevent="fromSubmit">
                            <!-- Wallet -->
                            <div class="row">
                                <div class="col-md-4">
                                    <h5>{{ trans.get('__JSON__.Basic Wallet') }}</h5>
                                </div>
                                <div class="col-md-8">
                                    <div class="row">
                                        <div class="col-md-6 ">
                                            <div class="vendor-status ">
                                                <label class="switch">
                                                    <input type="checkbox"  class="switch-on" true-value="active"
                                                        false-value="inactive" v-model="setting.wallet_status" id="wallet_status" />
                                                    <div class="slider round">
                                                        <span class="on">{{ trans.get('__JSON__.Active') }}</span>
                                                        <span class="off">{{ trans.get('__JSON__.Inactive') }}</span>
                                                    </div>
                                                </label>
                                            </div>
                                        </div>
                                        <div class="col-md-12 mt-3">
                                            <p>{{ trans.get('__JSON__.Customer can use wallet to do payment and manage it from Profile in application.')}}</p>
                                        </div>
                                    </div>
                                    <!-- Maximum wallet amount limit -->
                                    <div class="row mt-4">
                                        <div class="col-md-12 ">
                                            <h6>{{ trans.get('__JSON__.Maximum wallet amount limit') }}</h6>
                                        </div>
                                        <div class="col-md-6">
                                            <input type="number" class="form-control" 
                                            id="maximum_wallet_amount"
                                            v-model="$v.setting.maximum_wallet_amount.$model"
                                            :class="{'is-invalid' : $v.setting.maximum_wallet_amount.$error}"
                                            >
                                            <div v-if="$v.setting.maximum_wallet_amount.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.maximum_wallet_amount.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                                <span v-if="!$v.setting.maximum_wallet_amount.minValue">
                                                    {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                </span>
                                            </div>

                                        </div>
                                    </div>
                                    <!-- Maximum wallet recharge limit -->
                                    <div class="row mt-3">
                                        <div class="col-md-12 ">
                                            <h6>{{ trans.get('__JSON__.Maximum wallet recharge limit') }}</h6>
                                        </div>
                                        <div class="col-md-6">
                                            <input type="number" class="form-control" 
                                            id="wallet_recharge_limit"
                                            v-model="$v.setting.wallet_recharge_limit.$model"
                                            :class="{'is-invalid' : $v.setting.wallet_recharge_limit.$error}"
                                            >
                                            <div v-if="$v.setting.wallet_recharge_limit.$error" class="invalid-feedback">
                                                <span v-if="!$v.setting.wallet_recharge_limit.required">
                                                    {{ trans.get('__JSON__.This field is required') }}
                                                </span>
                                                <span v-if="!$v.setting.wallet_recharge_limit.minValue">
                                                    {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row mt-4">
                                        <div class="col-md-6">
                                            <div class="vendor-status ">
                                                <label class="switch">
                                                    <input type="checkbox"  class="switch-on" true-value="active"
                                                    id="customer_wallet_recharge"
                                                    false-value="inactive" v-model="setting.customer_wallet_recharge" />
                                                    <div class="slider round">
                                                        <span class="on">{{ trans.get('__JSON__.Active') }}</span>
                                                        <span class="off">{{ trans.get('__JSON__.Inactive') }}</span>
                                                    </div>
                                                </label>
                                            </div>
                                            <p class="mt-3">{{ trans.get('__JSON__.This will enable wallet recharge to all customers.') }}</p>
                                        </div>
                                    </div>

                                </div>
                            </div>
                            <hr>
                            <!-- Loyalty Cash -->
                            <div class="row">
                                <div class="col-md-4">
                                    <h5>{{ trans.get('__JSON__.Loyalty Cash') }}</h5>
                                </div>
                                <div class="col-md-8">
                                    <div class="row">
                                        <div class="col-md-6 ">
                                            <div class="vendor-status ">
                                                <label class="switch">
                                                    <input type="checkbox"  class="switch-on" true-value="active"
                                                        id="loyalty_cash_status"
                                                        false-value="inactive" v-model="setting.loyalty_cash_status" />
                                                    <div class="slider round">
                                                        <span class="on">{{ trans.get('__JSON__.Active') }}</span>
                                                        <span class="off">{{ trans.get('__JSON__.Inactive') }}</span>
                                                    </div>
                                                </label>
                                            </div>
                                        </div>
                                        <div class="col-md-12 mt-3">
                                            <p>{{ trans.get('__JSON__.Customer will get Cash rewards in wallet when order get delivered.')}}</p>
                                        </div>
                                    </div>
                                    <template v-if="setting.loyalty_cash_status == 'active'">
                                        <!-- Minimum item total in order for earning -->
                                        <div class="row mt-4">
                                            <div class="col-md-12 ">
                                                <h6>{{ trans.get('__JSON__.Minimum item total in order for earning') }}</h6>
                                            </div>
                                            <div class="col-md-6">
                                                <input type="number" class="form-control" 
                                                id="loyalty_cash_minimum_item_total"
                                                v-model="$v.setting.loyalty_cash_minimum_item_total.$model"
                                                :class="{'is-invalid' : $v.setting.loyalty_cash_minimum_item_total.$error}"
                                                >
                                                <div v-if="$v.setting.loyalty_cash_minimum_item_total.$error" class="invalid-feedback">
                                                    <span v-if="!$v.setting.loyalty_cash_minimum_item_total.required">
                                                        {{ trans.get('__JSON__.This field is required') }}
                                                    </span>
                                                    <span v-if="!$v.setting.loyalty_cash_minimum_item_total.minValue">
                                                        {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                    </span>
                                                </div>
                                            </div>
                                        </div>
                                        <!-- Loyalty Cash Value (In Percentage) -->
                                        <div class="row mt-2">
                                            <div class="col-md-12 ">
                                                <h6>{{ trans.get('__JSON__.Loyalty Cash Value (In Percentage)') }}</h6>
                                            </div>
                                            <div class="col-md-6">
                                                <input type="number" class="form-control" 
                                                id="loyalty_cash_percentage"
                                                v-model="$v.setting.loyalty_cash_percentage.$model"
                                                :class="{'is-invalid' : $v.setting.loyalty_cash_percentage.$error}"
                                                >
                                                <div v-if="$v.setting.loyalty_cash_percentage.$error" class="invalid-feedback">
                                                    <span v-if="!$v.setting.loyalty_cash_percentage.required">
                                                        {{ trans.get('__JSON__.This field is required') }}
                                                    </span>
                                                    <span v-if="!$v.setting.loyalty_cash_percentage.minValue">
                                                        {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                    </span>
                                                </div>
                                            </div>
                                            <div class="col-md-12 mt-2">
                                                <p>{{ trans.get('__JSON__.So How it will work ? :') }}</p>
                                                <p class="mt-3">{{ trans.get('__JSON__.If Customer will Place an order with 500 $, Customer will get 10 $ Loyalty cash in wallet after Delivery of order & They can use that Loyalty cash for next order.') }}</p>
                                            </div>
                                        </div>
                                    </template>

                                </div>
                            </div>
                            <hr>
                            <!-- Refer & Earn -->
                            <div class="row">
                                <div class="col-md-4">
                                    <h5>{{ trans.get('__JSON__.Refer & Earn') }}</h5>
                                </div>
                                <div class="col-md-8">
                                    <div class="row">
                                        <div class="col-md-6 ">
                                            <div class="vendor-status ">
                                                <label class="switch">
                                                    <input type="checkbox"  class="switch-on" true-value="yes"
                                                        id="is_referral_enable"
                                                        false-value="no" v-model="setting.is_referral_enable" />
                                                    <div class="slider round">
                                                        <span class="on">{{ trans.get('__JSON__.Yes') }}</span>
                                                        <span class="off">{{ trans.get('__JSON__.No') }}</span>
                                                    </div>
                                                </label>
                                            </div>
                                        </div>
                                    </div>

                                    <template v-if="setting.is_referral_enable == 'yes'">
                                        <!-- Referral Amount -->
                                        <div class="row mt-4">
                                            <div class="col-md-12 ">
                                                <h6>{{ trans.get('__JSON__.Referral Amount') }}</h6>
                                            </div>
                                            <div class="col-md-6">
                                                <input type="number" class="form-control" 
                                                id="referral_amount"
                                                v-model="$v.setting.referral_amount.$model"
                                                :class="{'is-invalid' : $v.setting.referral_amount.$error}"
                                                >
                                                <div v-if="$v.setting.referral_amount.$error" class="invalid-feedback">
                                                    <span v-if="!$v.setting.referral_amount.required">
                                                        {{ trans.get('__JSON__.This field is required') }}
                                                    </span>
                                                    <span v-if="!$v.setting.referral_amount.minValue">
                                                        {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                    </span>
                                                </div>
                                            </div>
                                        </div>
                                        <!-- Referee Amount -->
                                        <div class="row mt-2">
                                            <div class="col-md-12 ">
                                                <h6>{{ trans.get('__JSON__.Referee Amount') }}</h6>
                                            </div>
                                            <div class="col-md-6">
                                                <input type="number" class="form-control" 
                                                id="referee_amount"
                                                v-model="$v.setting.referee_amount.$model"
                                                :class="{'is-invalid' : $v.setting.referee_amount.$error}"
                                                >
                                                <div v-if="$v.setting.referee_amount.$error" class="invalid-feedback">
                                                    <span v-if="!$v.setting.referee_amount.required">
                                                        {{ trans.get('__JSON__.This field is required') }}
                                                    </span>
                                                    <span v-if="!$v.setting.referee_amount.minValue">
                                                        {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                                    </span>
                                                </div>
                                            </div>
                                            <div class="col-md-12 mt-2">
                                                <p>{{ trans.get('__JSON__.So How it will work ? :') }}</p>
                                                <p class="mt-3">{{ trans.get('__JSON__.If Customer will Place an order with 500 $, Customer will get 10 $ Loyalty cash in wallet after Delivery of order & They can use that Loyalty cash for next order.') }}</p>
                                            </div>
                                        </div>
                                    </template>
                                </div>
                            </div>
                            <hr>
                            <button type="submit" class="form-controle btn btn-primary">
                                {{ trans.get('__JSON__.Update') }}
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

